#pragma	option	-zC_INIT

#pragma hdrfile "WinGauge.SYM"
#include <win31.h>
#include "wingauge.h"
#include "wingauge.rh"
#pragma hdrstop


static	char		szAppName[] = "WinGauge";
static	GLOBALHANDLE	hInstCount;


/*--------------------==================================--------------------*/
/*	   Check instance counter and prevent from too many instances       */
/*--------------------==================================--------------------*/


BOOL FAR PreventMultiply( HANDLE hPrevInst )
{ WORD far *pInstCount;
  BOOL	    bPrevent;

  if( !hPrevInst )			// Get handle of shared memory block
    hInstCount = GlobalAlloc( GHND | GMEM_SHARE, sizeof(WORD) );
  else
    GetInstanceData( hPrevInst, (NPSTR)&hInstCount, sizeof(WORD) );

  pInstCount = (WORD far *)GlobalLock( hInstCount );	// Take instance count
  if( *pInstCount == 3 )
    { HWND hWnd;			// Prevent too many instances
      char cBuffer[80];

      hWnd = FindWindow( MAKEINTRESOURCE(DIALOG), "Windows Gauge" );
      SetActiveWindow( hWnd );
      LoadString( hInst, IDS_ALROPEN, cBuffer, sizeof(cBuffer) );
      MessageBox( hWnd, cBuffer, szAppName, MB_ICONASTERISK | MB_OK );
      bPrevent = TRUE;
    }
  else
    { ++*pInstCount;			// Increment instance count
      bPrevent = FALSE;
    }

  GlobalUnlock( hInstCount );

  return bPrevent;
}


/*--------------------==================================--------------------*/
/*       Proceed WM_INITDIALOG message -- initialise global variables       */
/*--------------------==================================--------------------*/


void FAR InitDialog( HWND hWnd )
{ HMENU hMenu;
  int	i;
  char  cBuffer[80];
  WORD  wVersion;

  LoadString( hInst, IDS_MANYCLOCKS, cBuffer, sizeof(cBuffer) );

  while( !SetTimer( hWnd, 1, 1, NULL ) )	   // Set timer (18 ticks/sec)
    if( IDCANCEL == MessageBox( hWnd, cBuffer, szAppName,
				MB_ICONEXCLAMATION | MB_RETRYCANCEL ) )
      { EndDialog( hWnd, 1 );
	return;
      }

  hMenu = GetSystemMenu( hWnd, FALSE );
  AppendMenu( hMenu, MF_SEPARATOR, 0,         NULL );
  AppendMenu( hMenu, MF_STRING,    IDM_ABOUT, "&About WinGauge..." );

  wVersion = GetVersion();	       // Following will work only in Win 3.10+
  if( LOBYTE(wVersion) * 256 + HIBYTE(wVersion) >= 0x30A )
     { AppendMenu( hMenu, MF_STRING|MF_CHECKED, IDM_ONTOP, "Always on &Top" );
       bAlwaysOnTop = TRUE;
       SetWindowPos( hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE );
     }

  ahCursors[0] = LoadCursor( hInst, MAKEINTRESOURCE(1) );
  for( i=1; i<4; ++i )
    { ahCursors[i] = LoadCursor( hInst, MAKEINTRESOURCE(i+1) );
      ahBitmaps[i] = LoadBitmap( hInst, MAKEINTRESOURCE(i) );
    }

}


/*--------------------==================================--------------------*/
/*	       Proceed WM_CLOSE message -- make some clearance	    	    */
/*--------------------==================================--------------------*/


void FAR FinishDialog( HWND hWnd )
{ int i;
  FreeResource( ahCursors[0] );		// Delete main monochrome icon,
  for( i=1; i<4; ++i )			//
    { FreeResource( ahCursors[i] );	//	  other monochrome icons,
      DeleteObject( ahBitmaps[i] );	//	  panel bitmaps,
    }					//
  KillTimer( hWnd, 1 );			//	  and timer.

  i = --*(WORD far *)GlobalLock( hInstCount );	// Decrement instance counter
  GlobalUnlock( hInstCount );
  if( i == 0 )
    GlobalFree( hInstCount );		// Free shared memory block

  EndDialog( hWnd, 0 );
}
