#pragma hdrfile "WinGauge.SYM"
#include <win31.h>
#include "wingauge.h"
#include "wingauge.rh"
#pragma hdrstop

#include <stdio.h>
#include <mem.h>

BOOL    bAlwaysOnTop;

static	short	sGauge = 0;

HBITMAP	ahBitmaps[4];
HCURSOR	ahCursors[4];
NPPAINT	afnPaint[4] = { NULL, wmPaint, rmPaint, mmPaint };

	WORD	awNew[4];
static	WORD	awOld[4];

BOOL FAR PASCAL WndProc( HWND hWnd, WORD iMessage, WORD wParam, LONG lParam )
{ static HBRUSH  hBrush;

  switch( iMessage )
    { case WM_INITDIALOG:
	  InitDialog( hWnd );
	  hBrush = GetStockObject( LTGRAY_BRUSH );
			/* FALL THRU */
      case WM_TIMER:
	  scope
	    { static short sClicks = 0;
	      char cBuffer[16];

	      awNew[WINMETER] = wmTimer();
	      if( --sClicks < 0 )
		{ sClicks = 18/2;
		  awNew[RESMETER] = rmTimer();
		  awNew[MEMMETER] = mmTimer();
		  sprintf( cBuffer, "(tasks:%2d)", GetNumTasks() );
		  SetDlgItemText( hWnd, IDD_TASK, cBuffer );
		}
	    }
	  if( IsIconic( hWnd ) )
	    { if( awNew[sGauge] != awOld[sGauge] )
		InvalidateRect( hWnd, NULL, FALSE );
	    }
	  else
	    { short i;
	      for( i=1; i<4; ++i )
		if( awNew[i] != awOld[i] )
		  InvalidateRect( GetDlgItem( hWnd, i ), NULL, FALSE );
	    }
	  memcpy( awOld, awNew, sizeof(awNew) );
	  return TRUE;

      case WM_SYSCOMMAND:
	  if( wParam == IDM_ABOUT )
	    { FARPROC lpfnAbout;

	      lpfnAbout = MakeProcInstance( (FARPROC)AboutDlgProc, hInst );
	      DialogBoxParam( hInst, MAKEINTRESOURCE( ABOUTDLG ),
			      hWnd, lpfnAbout, sGauge );
	      FreeProcInstance( lpfnAbout );
	      return TRUE;
	    }
	  else if( wParam == IDM_ONTOP )
	    { bAlwaysOnTop = !bAlwaysOnTop;
	      CheckMenuItem( GetSystemMenu( hWnd, FALSE ), IDM_ONTOP,
			       (bAlwaysOnTop ? MF_CHECKED : MF_UNCHECKED) );
	      SetWindowPos( hWnd, (bAlwaysOnTop ? HWND_TOPMOST :
						  HWND_NOTOPMOST),
				      0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE );
	    }
	  break;

      case WM_COMMAND:
	  if( LOWORD(lParam) )
	    { if( HIWORD(lParam) == BN_CLICKED )
		{ if( sGauge )
		    InvalidateRect( GetDlgItem( hWnd, sGauge ), NULL, FALSE );
		  sGauge = ( sGauge == wParam ? 0 : wParam );
		  if( sGauge )
		    InvalidateRect( GetDlgItem( hWnd, sGauge ), NULL, FALSE );
		  return TRUE;
		}
	      if( HIWORD(lParam) == BN_DOUBLECLICKED && sGauge )
		{ ShowWindow( hWnd, SW_MINIMIZE );
		  return TRUE;
		}
	    }
	  break;

      case WM_CTLCOLOR:                 // Select color for background paint
	  scope
	    { POINT point;

	      SetBkColor( wParam, LIGHTGRAY );
	      UnrealizeObject( hBrush );
	      point.x = point.y = 0;
	      ClientToScreen( hWnd, &point );
	      SetBrushOrg( wParam, point.x, point.y );
	    }
	  return hBrush;

      case WM_DRAWITEM:
	  DrawButton( (LPDRAWITEMSTRUCT)lParam, sGauge );
	  return TRUE;

      case WM_PAINT:
	  if( IsIconic( hWnd ) )		// Paint only into icon
	    { PaintIcon( hWnd, sGauge );
	      return TRUE;
	    }
	  break;

      case WM_QUERYDRAGICON:		// Set monochrome icon during draging
		//
		// Sorry, this code doesn't work with Windows 3.0
		//	( due to Microsoft Windows staff, of course! ).
		// They have improved themselves in Windows 3.1,
		//      so it's leaved here.
		//
		// See DefDlgProc in SDK for causes and reasons.
		//
	  return ahCursors[sGauge];

      case WM_CLOSE:
	  FinishDialog( hWnd );
	  return TRUE;
    }
  return FALSE;
}
